# This file was automatically generated by SWIG (http://www.swig.org).
# Version 3.0.2
#
# Do not make changes to this file unless you know what you are doing--modify
# the SWIG interface file instead.




"""

PyTrilinos.Amesos is the python interface to the Trilinos direct
linear solver package Amesos:

    http://trilinos.sandia.gov/packages/amesos

The purpose of Amesos is to provide a common interface to a variety of
third-party direct solvers, made compatible with PyTrilinos.Epetra.
Note that the C++ version of Amesos uses the prefix 'Amesos_', which
has been stripped from the python implementation.

The most important classes of the Amesos module are:

    * Factory      - Factory class
    * Lapack       - LAPACK interface
    * Klu          - KLU interface
    * Umfpack      - UMFPACK interface
    * Scalapack    - SCALAPACK interface
    * Superlu      - SuperLU interface
    * Superludist  - SuperLU_DIST interface
    * Dscpack      - DSCPACK interface
    * Mumps        - MUMPS interface

Use dir(Amesos) to see what specific interfaces have been enabled on
your platform.  For examples of usage, please consult the examples
subdirectory of the PyTrilinos package, scripts exAmesos_Simple.py and
exAmesos_Factory.py.

"""


from sys import version_info
if version_info >= (2,6,0):
    def swig_import_helper():
        from os.path import dirname
        import imp
        fp = None
        try:
            fp, pathname, description = imp.find_module('_Amesos', [dirname(__file__)])
        except ImportError:
            import _Amesos
            return _Amesos
        if fp is not None:
            try:
                _mod = imp.load_module('_Amesos', fp, pathname, description)
            finally:
                fp.close()
            return _mod
    _Amesos = swig_import_helper()
    del swig_import_helper
else:
    import _Amesos
del version_info
try:
    _swig_property = property
except NameError:
    pass # Python < 2.2 doesn't have 'property'.
def _swig_setattr_nondynamic(self,class_type,name,value,static=1):
    if (name == "thisown"): return self.this.own(value)
    if (name == "this"):
        if type(value).__name__ == 'SwigPyObject':
            self.__dict__[name] = value
            return
    method = class_type.__swig_setmethods__.get(name,None)
    if method: return method(self,value)
    if (not static):
        self.__dict__[name] = value
    else:
        raise AttributeError("You cannot add attributes to %s" % self)

def _swig_setattr(self,class_type,name,value):
    return _swig_setattr_nondynamic(self,class_type,name,value,0)

def _swig_getattr(self,class_type,name):
    if (name == "thisown"): return self.this.own()
    method = class_type.__swig_getmethods__.get(name,None)
    if method: return method(self)
    raise AttributeError(name)

def _swig_repr(self):
    try: strthis = "proxy of " + self.this.__repr__()
    except: strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)

try:
    _object = object
    _newclass = 1
except AttributeError:
    class _object : pass
    _newclass = 0


try:
    import weakref
    weakref_proxy = weakref.proxy
except:
    weakref_proxy = lambda x: x


class SwigPyIterator(_object):
    """Proxy of C++ swig::SwigPyIterator class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, SwigPyIterator, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, SwigPyIterator, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Amesos.delete_SwigPyIterator
    def value(self):
        """value(SwigPyIterator self) -> PyObject *"""
        return _Amesos.SwigPyIterator_value(self)

    def incr(self, n=1):
        """
        incr(SwigPyIterator self, size_t n=1) -> SwigPyIterator
        incr(SwigPyIterator self) -> SwigPyIterator
        """
        return _Amesos.SwigPyIterator_incr(self, n)

    def decr(self, n=1):
        """
        decr(SwigPyIterator self, size_t n=1) -> SwigPyIterator
        decr(SwigPyIterator self) -> SwigPyIterator
        """
        return _Amesos.SwigPyIterator_decr(self, n)

    def distance(self, *args):
        """distance(SwigPyIterator self, SwigPyIterator x) -> ptrdiff_t"""
        return _Amesos.SwigPyIterator_distance(self, *args)

    def equal(self, *args):
        """equal(SwigPyIterator self, SwigPyIterator x) -> bool"""
        return _Amesos.SwigPyIterator_equal(self, *args)

    def copy(self):
        """copy(SwigPyIterator self) -> SwigPyIterator"""
        return _Amesos.SwigPyIterator_copy(self)

    def next(self):
        """next(SwigPyIterator self) -> PyObject *"""
        return _Amesos.SwigPyIterator_next(self)

    def __next__(self):
        """__next__(SwigPyIterator self) -> PyObject *"""
        return _Amesos.SwigPyIterator___next__(self)

    def previous(self):
        """previous(SwigPyIterator self) -> PyObject *"""
        return _Amesos.SwigPyIterator_previous(self)

    def advance(self, *args):
        """advance(SwigPyIterator self, ptrdiff_t n) -> SwigPyIterator"""
        return _Amesos.SwigPyIterator_advance(self, *args)

    def __eq__(self, *args):
        """__eq__(SwigPyIterator self, SwigPyIterator x) -> bool"""
        return _Amesos.SwigPyIterator___eq__(self, *args)

    def __ne__(self, *args):
        """__ne__(SwigPyIterator self, SwigPyIterator x) -> bool"""
        return _Amesos.SwigPyIterator___ne__(self, *args)

    def __iadd__(self, *args):
        """__iadd__(SwigPyIterator self, ptrdiff_t n) -> SwigPyIterator"""
        return _Amesos.SwigPyIterator___iadd__(self, *args)

    def __isub__(self, *args):
        """__isub__(SwigPyIterator self, ptrdiff_t n) -> SwigPyIterator"""
        return _Amesos.SwigPyIterator___isub__(self, *args)

    def __add__(self, *args):
        """__add__(SwigPyIterator self, ptrdiff_t n) -> SwigPyIterator"""
        return _Amesos.SwigPyIterator___add__(self, *args)

    def __sub__(self, *args):
        """
        __sub__(SwigPyIterator self, ptrdiff_t n) -> SwigPyIterator
        __sub__(SwigPyIterator self, SwigPyIterator x) -> ptrdiff_t
        """
        return _Amesos.SwigPyIterator___sub__(self, *args)

    def __iter__(self): return self
SwigPyIterator_swigregister = _Amesos.SwigPyIterator_swigregister
SwigPyIterator_swigregister(SwigPyIterator)

import PyTrilinos.Teuchos
import PyTrilinos.Epetra
class Factory(_object):
    """Proxy of C++ Amesos class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, Factory, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, Factory, name)
    __repr__ = _swig_repr
    def Create(self, *args):
        """
        Create(Factory self, char const * ClassType, LinearProblem LinearProblem) -> BaseSolver
        Create(Factory self, std::string const CT, LinearProblem LinearProblem) -> BaseSolver
        """
        return _Amesos.Factory_Create(self, *args)

    def Query(self, *args):
        """
        Query(Factory self, char const * ClassType) -> bool
        Query(Factory self, std::string const CT) -> bool
        """
        return _Amesos.Factory_Query(self, *args)

    def GetValidParameters(*args):
        """GetValidParameters() -> ParameterList"""
        return _Amesos.Factory_GetValidParameters(*args)

    if _newclass:GetValidParameters = staticmethod(GetValidParameters)
    __swig_getmethods__["GetValidParameters"] = lambda x: GetValidParameters
    def __init__(self, *args): 
        """__init__(Amesos self) -> Factory"""
        this = _Amesos.new_Factory(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Amesos.delete_Factory
Factory_swigregister = _Amesos.Factory_swigregister
Factory_swigregister(Factory)

def Factory_GetValidParameters(*args):
  """Factory_GetValidParameters() -> ParameterList"""
  return _Amesos.Factory_GetValidParameters(*args)

class BaseSolver(PyTrilinos.Teuchos.ParameterListAcceptor):
    """Proxy of C++ Amesos_BaseSolver class"""
    __swig_setmethods__ = {}
    for _s in [PyTrilinos.Teuchos.ParameterListAcceptor]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, BaseSolver, name, value)
    __swig_getmethods__ = {}
    for _s in [PyTrilinos.Teuchos.ParameterListAcceptor]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, BaseSolver, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    def getParameterList(self, *args):
        """getParameterList(BaseSolver self) -> Teuchos::RCP< Teuchos::ParameterList const >"""
        return _Amesos.BaseSolver_getParameterList(self, *args)

    __swig_destroy__ = _Amesos.delete_BaseSolver
    def SymbolicFactorization(self, *args):
        """SymbolicFactorization(BaseSolver self) -> int"""
        return _Amesos.BaseSolver_SymbolicFactorization(self, *args)

    def NumericFactorization(self, *args):
        """NumericFactorization(BaseSolver self) -> int"""
        return _Amesos.BaseSolver_NumericFactorization(self, *args)

    def Solve(self, *args):
        """Solve(BaseSolver self) -> int"""
        return _Amesos.BaseSolver_Solve(self, *args)

    def SetUseTranspose(self, *args):
        """SetUseTranspose(BaseSolver self, bool UseTranspose) -> int"""
        return _Amesos.BaseSolver_SetUseTranspose(self, *args)

    def UseTranspose(self, *args):
        """UseTranspose(BaseSolver self) -> bool"""
        return _Amesos.BaseSolver_UseTranspose(self, *args)

    def SetParameters(self, *args):
        """SetParameters(BaseSolver self, ParameterList ParameterList) -> int"""
        return _Amesos.BaseSolver_SetParameters(self, *args)

    def GetProblem(self, *args):
        """GetProblem(BaseSolver self) -> LinearProblem"""
        return _Amesos.BaseSolver_GetProblem(self, *args)

    def MatrixShapeOK(self, *args):
        """MatrixShapeOK(BaseSolver self) -> bool"""
        return _Amesos.BaseSolver_MatrixShapeOK(self, *args)

    def Comm(self, *args):
        """Comm(BaseSolver self) -> Comm"""
        return _Amesos.BaseSolver_Comm(self, *args)

    def NumSymbolicFact(self, *args):
        """NumSymbolicFact(BaseSolver self) -> int"""
        return _Amesos.BaseSolver_NumSymbolicFact(self, *args)

    def NumNumericFact(self, *args):
        """NumNumericFact(BaseSolver self) -> int"""
        return _Amesos.BaseSolver_NumNumericFact(self, *args)

    def NumSolve(self, *args):
        """NumSolve(BaseSolver self) -> int"""
        return _Amesos.BaseSolver_NumSolve(self, *args)

    def PrintStatus(self, *args):
        """PrintStatus(BaseSolver self)"""
        return _Amesos.BaseSolver_PrintStatus(self, *args)

    def PrintTiming(self, *args):
        """PrintTiming(BaseSolver self)"""
        return _Amesos.BaseSolver_PrintTiming(self, *args)

    def setParameterList(self, *args):
        """setParameterList(BaseSolver self, Teuchos::RCP< Teuchos::ParameterList > const & paramList)"""
        return _Amesos.BaseSolver_setParameterList(self, *args)

    def getNonconstParameterList(self, *args):
        """getNonconstParameterList(BaseSolver self) -> Teuchos::RCP< Teuchos::ParameterList >"""
        return _Amesos.BaseSolver_getNonconstParameterList(self, *args)

    def unsetParameterList(self, *args):
        """unsetParameterList(BaseSolver self) -> Teuchos::RCP< Teuchos::ParameterList >"""
        return _Amesos.BaseSolver_unsetParameterList(self, *args)

    def GetTiming(self, *args):
        """GetTiming(BaseSolver self, ParameterList TimingParameterList)"""
        return _Amesos.BaseSolver_GetTiming(self, *args)

BaseSolver_swigregister = _Amesos.BaseSolver_swigregister
BaseSolver_swigregister(BaseSolver)
cvar = _Amesos.cvar
StructurallySingularMatrixError = cvar.StructurallySingularMatrixError
NumericallySingularMatrixError = cvar.NumericallySingularMatrixError

class Lapack(BaseSolver):
    """Proxy of C++ Amesos_Lapack class"""
    __swig_setmethods__ = {}
    for _s in [BaseSolver]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Lapack, name, value)
    __swig_getmethods__ = {}
    for _s in [BaseSolver]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Lapack, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """__init__(Amesos_Lapack self, LinearProblem LinearProblem) -> Lapack"""
        this = _Amesos.new_Lapack(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Amesos.delete_Lapack
    def SymbolicFactorization(self, *args):
        """SymbolicFactorization(Lapack self) -> int"""
        return _Amesos.Lapack_SymbolicFactorization(self, *args)

    def NumericFactorization(self, *args):
        """NumericFactorization(Lapack self) -> int"""
        return _Amesos.Lapack_NumericFactorization(self, *args)

    def Solve(self, *args):
        """Solve(Lapack self) -> int"""
        return _Amesos.Lapack_Solve(self, *args)

    def GetProblem(self, *args):
        """GetProblem(Lapack self) -> LinearProblem"""
        return _Amesos.Lapack_GetProblem(self, *args)

    def MatrixShapeOK(self, *args):
        """MatrixShapeOK(Lapack self) -> bool"""
        return _Amesos.Lapack_MatrixShapeOK(self, *args)

    def SetUseTranspose(self, *args):
        """SetUseTranspose(Lapack self, bool UseTranspose_in) -> int"""
        return _Amesos.Lapack_SetUseTranspose(self, *args)

    def UseTranspose(self, *args):
        """UseTranspose(Lapack self) -> bool"""
        return _Amesos.Lapack_UseTranspose(self, *args)

    def Comm(self, *args):
        """Comm(Lapack self) -> Comm"""
        return _Amesos.Lapack_Comm(self, *args)

    def setParameterList(self, *args):
        """setParameterList(Lapack self, Teuchos::RCP< Teuchos::ParameterList > const & paramList)"""
        return _Amesos.Lapack_setParameterList(self, *args)

    def unsetParameterList(self, *args):
        """unsetParameterList(Lapack self) -> Teuchos::RCP< Teuchos::ParameterList >"""
        return _Amesos.Lapack_unsetParameterList(self, *args)

    def SetParameters(self, *args):
        """SetParameters(Lapack self, ParameterList ParameterList) -> int"""
        return _Amesos.Lapack_SetParameters(self, *args)

    def GEEV(self, *args):
        """GEEV(Lapack self, Epetra_Vector Er, Epetra_Vector Ei) -> int"""
        return _Amesos.Lapack_GEEV(self, *args)

    def NumSymbolicFact(self, *args):
        """NumSymbolicFact(Lapack self) -> int"""
        return _Amesos.Lapack_NumSymbolicFact(self, *args)

    def NumNumericFact(self, *args):
        """NumNumericFact(Lapack self) -> int"""
        return _Amesos.Lapack_NumNumericFact(self, *args)

    def NumSolve(self, *args):
        """NumSolve(Lapack self) -> int"""
        return _Amesos.Lapack_NumSolve(self, *args)

    def PrintTiming(self, *args):
        """PrintTiming(Lapack self)"""
        return _Amesos.Lapack_PrintTiming(self, *args)

    def PrintStatus(self, *args):
        """PrintStatus(Lapack self)"""
        return _Amesos.Lapack_PrintStatus(self, *args)

    def GetTiming(self, *args):
        """GetTiming(Lapack self, ParameterList TimingParameterList)"""
        return _Amesos.Lapack_GetTiming(self, *args)

Lapack_swigregister = _Amesos.Lapack_swigregister
Lapack_swigregister(Lapack)

class Klu(BaseSolver):
    """Proxy of C++ Amesos_Klu class"""
    __swig_setmethods__ = {}
    for _s in [BaseSolver]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Klu, name, value)
    __swig_getmethods__ = {}
    for _s in [BaseSolver]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Klu, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """__init__(Amesos_Klu self, LinearProblem LinearProblem) -> Klu"""
        this = _Amesos.new_Klu(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Amesos.delete_Klu
    def SymbolicFactorization(self, *args):
        """SymbolicFactorization(Klu self) -> int"""
        return _Amesos.Klu_SymbolicFactorization(self, *args)

    def NumericFactorization(self, *args):
        """NumericFactorization(Klu self) -> int"""
        return _Amesos.Klu_NumericFactorization(self, *args)

    def Solve(self, *args):
        """Solve(Klu self) -> int"""
        return _Amesos.Klu_Solve(self, *args)

    def GetProblem(self, *args):
        """GetProblem(Klu self) -> LinearProblem"""
        return _Amesos.Klu_GetProblem(self, *args)

    def MatrixShapeOK(self, *args):
        """MatrixShapeOK(Klu self) -> bool"""
        return _Amesos.Klu_MatrixShapeOK(self, *args)

    def SetUseTranspose(self, *args):
        """SetUseTranspose(Klu self, bool UseTranspose_in) -> int"""
        return _Amesos.Klu_SetUseTranspose(self, *args)

    def UseTranspose(self, *args):
        """UseTranspose(Klu self) -> bool"""
        return _Amesos.Klu_UseTranspose(self, *args)

    def Comm(self, *args):
        """Comm(Klu self) -> Comm"""
        return _Amesos.Klu_Comm(self, *args)

    def SetParameters(self, *args):
        """SetParameters(Klu self, ParameterList ParameterList) -> int"""
        return _Amesos.Klu_SetParameters(self, *args)

    def NumSymbolicFact(self, *args):
        """NumSymbolicFact(Klu self) -> int"""
        return _Amesos.Klu_NumSymbolicFact(self, *args)

    def NumNumericFact(self, *args):
        """NumNumericFact(Klu self) -> int"""
        return _Amesos.Klu_NumNumericFact(self, *args)

    def NumSolve(self, *args):
        """NumSolve(Klu self) -> int"""
        return _Amesos.Klu_NumSolve(self, *args)

    def PrintTiming(self, *args):
        """PrintTiming(Klu self)"""
        return _Amesos.Klu_PrintTiming(self, *args)

    def PrintStatus(self, *args):
        """PrintStatus(Klu self)"""
        return _Amesos.Klu_PrintStatus(self, *args)

    def GetTiming(self, *args):
        """GetTiming(Klu self, ParameterList TimingParameterList)"""
        return _Amesos.Klu_GetTiming(self, *args)

Klu_swigregister = _Amesos.Klu_swigregister
Klu_swigregister(Klu)

class Umfpack(BaseSolver):
    """Proxy of C++ Amesos_Umfpack class"""
    __swig_setmethods__ = {}
    for _s in [BaseSolver]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Umfpack, name, value)
    __swig_getmethods__ = {}
    for _s in [BaseSolver]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Umfpack, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """__init__(Amesos_Umfpack self, LinearProblem LinearProblem) -> Umfpack"""
        this = _Amesos.new_Umfpack(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Amesos.delete_Umfpack
    def SymbolicFactorization(self, *args):
        """SymbolicFactorization(Umfpack self) -> int"""
        return _Amesos.Umfpack_SymbolicFactorization(self, *args)

    def NumericFactorization(self, *args):
        """NumericFactorization(Umfpack self) -> int"""
        return _Amesos.Umfpack_NumericFactorization(self, *args)

    def Solve(self, *args):
        """Solve(Umfpack self) -> int"""
        return _Amesos.Umfpack_Solve(self, *args)

    def GetProblem(self, *args):
        """GetProblem(Umfpack self) -> LinearProblem"""
        return _Amesos.Umfpack_GetProblem(self, *args)

    def MatrixShapeOK(self, *args):
        """MatrixShapeOK(Umfpack self) -> bool"""
        return _Amesos.Umfpack_MatrixShapeOK(self, *args)

    def SetUseTranspose(self, *args):
        """SetUseTranspose(Umfpack self, bool UseTranspose_in) -> int"""
        return _Amesos.Umfpack_SetUseTranspose(self, *args)

    def UseTranspose(self, *args):
        """UseTranspose(Umfpack self) -> bool"""
        return _Amesos.Umfpack_UseTranspose(self, *args)

    def Comm(self, *args):
        """Comm(Umfpack self) -> Comm"""
        return _Amesos.Umfpack_Comm(self, *args)

    def GetRcond(self, *args):
        """GetRcond(Umfpack self) -> double"""
        return _Amesos.Umfpack_GetRcond(self, *args)

    def SetParameters(self, *args):
        """SetParameters(Umfpack self, ParameterList ParameterList) -> int"""
        return _Amesos.Umfpack_SetParameters(self, *args)

    def NumSymbolicFact(self, *args):
        """NumSymbolicFact(Umfpack self) -> int"""
        return _Amesos.Umfpack_NumSymbolicFact(self, *args)

    def NumNumericFact(self, *args):
        """NumNumericFact(Umfpack self) -> int"""
        return _Amesos.Umfpack_NumNumericFact(self, *args)

    def NumSolve(self, *args):
        """NumSolve(Umfpack self) -> int"""
        return _Amesos.Umfpack_NumSolve(self, *args)

    def PrintTiming(self, *args):
        """PrintTiming(Umfpack self)"""
        return _Amesos.Umfpack_PrintTiming(self, *args)

    def PrintStatus(self, *args):
        """PrintStatus(Umfpack self)"""
        return _Amesos.Umfpack_PrintStatus(self, *args)

    def GetTiming(self, *args):
        """GetTiming(Umfpack self, ParameterList TimingParameterList)"""
        return _Amesos.Umfpack_GetTiming(self, *args)

Umfpack_swigregister = _Amesos.Umfpack_swigregister
Umfpack_swigregister(Umfpack)

class Scalapack(BaseSolver):
    """Proxy of C++ Amesos_Scalapack class"""
    __swig_setmethods__ = {}
    for _s in [BaseSolver]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Scalapack, name, value)
    __swig_getmethods__ = {}
    for _s in [BaseSolver]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Scalapack, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """__init__(Amesos_Scalapack self, LinearProblem LinearProblem) -> Scalapack"""
        this = _Amesos.new_Scalapack(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Amesos.delete_Scalapack
    def SymbolicFactorization(self, *args):
        """SymbolicFactorization(Scalapack self) -> int"""
        return _Amesos.Scalapack_SymbolicFactorization(self, *args)

    def NumericFactorization(self, *args):
        """NumericFactorization(Scalapack self) -> int"""
        return _Amesos.Scalapack_NumericFactorization(self, *args)

    def Solve(self, *args):
        """Solve(Scalapack self) -> int"""
        return _Amesos.Scalapack_Solve(self, *args)

    def GetProblem(self, *args):
        """GetProblem(Scalapack self) -> LinearProblem"""
        return _Amesos.Scalapack_GetProblem(self, *args)

    def MatrixShapeOK(self, *args):
        """MatrixShapeOK(Scalapack self) -> bool"""
        return _Amesos.Scalapack_MatrixShapeOK(self, *args)

    def SetUseTranspose(self, *args):
        """SetUseTranspose(Scalapack self, bool UseTranspose) -> int"""
        return _Amesos.Scalapack_SetUseTranspose(self, *args)

    def UseTranspose(self, *args):
        """UseTranspose(Scalapack self) -> bool"""
        return _Amesos.Scalapack_UseTranspose(self, *args)

    def Comm(self, *args):
        """Comm(Scalapack self) -> Comm"""
        return _Amesos.Scalapack_Comm(self, *args)

    def SetParameters(self, *args):
        """SetParameters(Scalapack self, ParameterList ParameterList) -> int"""
        return _Amesos.Scalapack_SetParameters(self, *args)

    def NumSymbolicFact(self, *args):
        """NumSymbolicFact(Scalapack self) -> int"""
        return _Amesos.Scalapack_NumSymbolicFact(self, *args)

    def NumNumericFact(self, *args):
        """NumNumericFact(Scalapack self) -> int"""
        return _Amesos.Scalapack_NumNumericFact(self, *args)

    def NumSolve(self, *args):
        """NumSolve(Scalapack self) -> int"""
        return _Amesos.Scalapack_NumSolve(self, *args)

    def PrintTiming(self, *args):
        """PrintTiming(Scalapack self)"""
        return _Amesos.Scalapack_PrintTiming(self, *args)

    def PrintStatus(self, *args):
        """PrintStatus(Scalapack self)"""
        return _Amesos.Scalapack_PrintStatus(self, *args)

    def GetTiming(self, *args):
        """GetTiming(Scalapack self, ParameterList TimingParameterList)"""
        return _Amesos.Scalapack_GetTiming(self, *args)

Scalapack_swigregister = _Amesos.Scalapack_swigregister
Scalapack_swigregister(Scalapack)

class Taucs(BaseSolver):
    """Proxy of C++ Amesos_Taucs class"""
    __swig_setmethods__ = {}
    for _s in [BaseSolver]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Taucs, name, value)
    __swig_getmethods__ = {}
    for _s in [BaseSolver]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Taucs, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """__init__(Amesos_Taucs self, LinearProblem LinearProblem) -> Taucs"""
        this = _Amesos.new_Taucs(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Amesos.delete_Taucs
    def SymbolicFactorization(self, *args):
        """SymbolicFactorization(Taucs self) -> int"""
        return _Amesos.Taucs_SymbolicFactorization(self, *args)

    def NumericFactorization(self, *args):
        """NumericFactorization(Taucs self) -> int"""
        return _Amesos.Taucs_NumericFactorization(self, *args)

    def Solve(self, *args):
        """Solve(Taucs self) -> int"""
        return _Amesos.Taucs_Solve(self, *args)

    def GetProblem(self, *args):
        """GetProblem(Taucs self) -> LinearProblem"""
        return _Amesos.Taucs_GetProblem(self, *args)

    def MatrixShapeOK(self, *args):
        """MatrixShapeOK(Taucs self) -> bool"""
        return _Amesos.Taucs_MatrixShapeOK(self, *args)

    def SetUseTranspose(self, *args):
        """SetUseTranspose(Taucs self, bool UseTranspose) -> int"""
        return _Amesos.Taucs_SetUseTranspose(self, *args)

    def UseTranspose(self, *args):
        """UseTranspose(Taucs self) -> bool"""
        return _Amesos.Taucs_UseTranspose(self, *args)

    def Comm(self, *args):
        """Comm(Taucs self) -> Comm"""
        return _Amesos.Taucs_Comm(self, *args)

    def SetParameters(self, *args):
        """SetParameters(Taucs self, ParameterList ParameterList) -> int"""
        return _Amesos.Taucs_SetParameters(self, *args)

    def NumSymbolicFact(self, *args):
        """NumSymbolicFact(Taucs self) -> int"""
        return _Amesos.Taucs_NumSymbolicFact(self, *args)

    def NumNumericFact(self, *args):
        """NumNumericFact(Taucs self) -> int"""
        return _Amesos.Taucs_NumNumericFact(self, *args)

    def NumSolve(self, *args):
        """NumSolve(Taucs self) -> int"""
        return _Amesos.Taucs_NumSolve(self, *args)

    def PrintTiming(self, *args):
        """PrintTiming(Taucs self)"""
        return _Amesos.Taucs_PrintTiming(self, *args)

    def PrintStatus(self, *args):
        """PrintStatus(Taucs self)"""
        return _Amesos.Taucs_PrintStatus(self, *args)

    def GetTiming(self, *args):
        """GetTiming(Taucs self, ParameterList TimingParameterList)"""
        return _Amesos.Taucs_GetTiming(self, *args)

Taucs_swigregister = _Amesos.Taucs_swigregister
Taucs_swigregister(Taucs)

class Superludist(BaseSolver):
    """Proxy of C++ Amesos_Superludist class"""
    __swig_setmethods__ = {}
    for _s in [BaseSolver]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Superludist, name, value)
    __swig_getmethods__ = {}
    for _s in [BaseSolver]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Superludist, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """__init__(Amesos_Superludist self, LinearProblem LinearProblem) -> Superludist"""
        this = _Amesos.new_Superludist(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Amesos.delete_Superludist
    def SymbolicFactorization(self, *args):
        """SymbolicFactorization(Superludist self) -> int"""
        return _Amesos.Superludist_SymbolicFactorization(self, *args)

    def NumericFactorization(self, *args):
        """NumericFactorization(Superludist self) -> int"""
        return _Amesos.Superludist_NumericFactorization(self, *args)

    def Solve(self, *args):
        """Solve(Superludist self) -> int"""
        return _Amesos.Superludist_Solve(self, *args)

    def SetUseTranspose(self, *args):
        """SetUseTranspose(Superludist self, bool UseTranspose) -> int"""
        return _Amesos.Superludist_SetUseTranspose(self, *args)

    def GetProblem(self, *args):
        """GetProblem(Superludist self) -> LinearProblem"""
        return _Amesos.Superludist_GetProblem(self, *args)

    def MatrixShapeOK(self, *args):
        """MatrixShapeOK(Superludist self) -> bool"""
        return _Amesos.Superludist_MatrixShapeOK(self, *args)

    def UseTranspose(self, *args):
        """UseTranspose(Superludist self) -> bool"""
        return _Amesos.Superludist_UseTranspose(self, *args)

    def SetParameters(self, *args):
        """SetParameters(Superludist self, ParameterList ParameterList) -> int"""
        return _Amesos.Superludist_SetParameters(self, *args)

    def NumSymbolicFact(self, *args):
        """NumSymbolicFact(Superludist self) -> int"""
        return _Amesos.Superludist_NumSymbolicFact(self, *args)

    def NumNumericFact(self, *args):
        """NumNumericFact(Superludist self) -> int"""
        return _Amesos.Superludist_NumNumericFact(self, *args)

    def NumSolve(self, *args):
        """NumSolve(Superludist self) -> int"""
        return _Amesos.Superludist_NumSolve(self, *args)

    def PrintTiming(self, *args):
        """PrintTiming(Superludist self)"""
        return _Amesos.Superludist_PrintTiming(self, *args)

    def PrintStatus(self, *args):
        """PrintStatus(Superludist self)"""
        return _Amesos.Superludist_PrintStatus(self, *args)

    def GetTiming(self, *args):
        """GetTiming(Superludist self, ParameterList TimingParameterList)"""
        return _Amesos.Superludist_GetTiming(self, *args)

Superludist_swigregister = _Amesos.Superludist_swigregister
Superludist_swigregister(Superludist)

class Mumps(BaseSolver):
    """Proxy of C++ Amesos_Mumps class"""
    __swig_setmethods__ = {}
    for _s in [BaseSolver]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Mumps, name, value)
    __swig_getmethods__ = {}
    for _s in [BaseSolver]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Mumps, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """__init__(Amesos_Mumps self, LinearProblem LinearProblem) -> Mumps"""
        this = _Amesos.new_Mumps(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Amesos.delete_Mumps
    def SymbolicFactorization(self, *args):
        """SymbolicFactorization(Mumps self) -> int"""
        return _Amesos.Mumps_SymbolicFactorization(self, *args)

    def NumericFactorization(self, *args):
        """NumericFactorization(Mumps self) -> int"""
        return _Amesos.Mumps_NumericFactorization(self, *args)

    def Solve(self, *args):
        """Solve(Mumps self) -> int"""
        return _Amesos.Mumps_Solve(self, *args)

    def Destroy(self, *args):
        """Destroy(Mumps self)"""
        return _Amesos.Mumps_Destroy(self, *args)

    def SetUseTranspose(self, *args):
        """SetUseTranspose(Mumps self, bool UseTranspose_in) -> int"""
        return _Amesos.Mumps_SetUseTranspose(self, *args)

    def UseTranspose(self, *args):
        """UseTranspose(Mumps self) -> bool"""
        return _Amesos.Mumps_UseTranspose(self, *args)

    def SetParameters(self, *args):
        """SetParameters(Mumps self, ParameterList ParameterList) -> int"""
        return _Amesos.Mumps_SetParameters(self, *args)

    def NumSymbolicFact(self, *args):
        """NumSymbolicFact(Mumps self) -> int"""
        return _Amesos.Mumps_NumSymbolicFact(self, *args)

    def NumNumericFact(self, *args):
        """NumNumericFact(Mumps self) -> int"""
        return _Amesos.Mumps_NumNumericFact(self, *args)

    def NumSolve(self, *args):
        """NumSolve(Mumps self) -> int"""
        return _Amesos.Mumps_NumSolve(self, *args)

    def PrintTiming(self, *args):
        """PrintTiming(Mumps self)"""
        return _Amesos.Mumps_PrintTiming(self, *args)

    def PrintStatus(self, *args):
        """PrintStatus(Mumps self)"""
        return _Amesos.Mumps_PrintStatus(self, *args)

    def GetTiming(self, *args):
        """GetTiming(Mumps self, ParameterList TimingParameterList)"""
        return _Amesos.Mumps_GetTiming(self, *args)

    def SetPrecscaling(self, *args):
        """SetPrecscaling(Mumps self, double * ColSca, double * RowSca) -> int"""
        return _Amesos.Mumps_SetPrecscaling(self, *args)

    def SetRowScaling(self, *args):
        """SetRowScaling(Mumps self, double * RowSca) -> int"""
        return _Amesos.Mumps_SetRowScaling(self, *args)

    def SetColScaling(self, *args):
        """SetColScaling(Mumps self, double * ColSca) -> int"""
        return _Amesos.Mumps_SetColScaling(self, *args)

    def SetOrdering(self, *args):
        """SetOrdering(Mumps self, int * PermIn) -> int"""
        return _Amesos.Mumps_SetOrdering(self, *args)

    def GetRINFO(self, *args):
        """GetRINFO(Mumps self) -> double *"""
        return _Amesos.Mumps_GetRINFO(self, *args)

    def GetINFO(self, *args):
        """GetINFO(Mumps self) -> int *"""
        return _Amesos.Mumps_GetINFO(self, *args)

    def GetRINFOG(self, *args):
        """GetRINFOG(Mumps self) -> double *"""
        return _Amesos.Mumps_GetRINFOG(self, *args)

    def GetINFOG(self, *args):
        """GetINFOG(Mumps self) -> int *"""
        return _Amesos.Mumps_GetINFOG(self, *args)

    def SetICNTL(self, *args):
        """SetICNTL(Mumps self, int pos, int value)"""
        return _Amesos.Mumps_SetICNTL(self, *args)

    def SetCNTL(self, *args):
        """SetCNTL(Mumps self, int pos, double value)"""
        return _Amesos.Mumps_SetCNTL(self, *args)

    def MatrixShapeOK(self, *args):
        """MatrixShapeOK(Mumps self) -> bool"""
        return _Amesos.Mumps_MatrixShapeOK(self, *args)

    def Comm(self, *args):
        """Comm(Mumps self) -> Comm"""
        return _Amesos.Mumps_Comm(self, *args)

    def GetProblem(self, *args):
        """GetProblem(Mumps self) -> LinearProblem"""
        return _Amesos.Mumps_GetProblem(self, *args)

Mumps_swigregister = _Amesos.Mumps_swigregister
Mumps_swigregister(Mumps)

# This file is compatible with both classic and new-style classes.


