# This file was automatically generated by SWIG (http://www.swig.org).
# Version 3.0.2
#
# Do not make changes to this file unless you know what you are doing--modify
# the SWIG interface file instead.




"""

PyTrilinos.LOCA.AnasaziOperator is the python interface to namespace
AnasaziOperator of the Trilinos continuation algorithm package LOCA:

    http://trilinos.sandia.gov/packages/nox

The purpose of LOCA.AnasaziOperator is to provide ***.  The python
version of LOCA.AnasaziOperator supports the following classes:

    * AbstractStrategy  - Abstract interface class for Anasazi operator
                          strategies
    * Factory           - Factory for creating Anasazi operator strategy
                          objects

"""


from sys import version_info
if version_info >= (2,6,0):
    def swig_import_helper():
        from os.path import dirname
        import imp
        fp = None
        try:
            fp, pathname, description = imp.find_module('_AnasaziOperator', [dirname(__file__)])
        except ImportError:
            import _AnasaziOperator
            return _AnasaziOperator
        if fp is not None:
            try:
                _mod = imp.load_module('_AnasaziOperator', fp, pathname, description)
            finally:
                fp.close()
            return _mod
    _AnasaziOperator = swig_import_helper()
    del swig_import_helper
else:
    import _AnasaziOperator
del version_info
try:
    _swig_property = property
except NameError:
    pass # Python < 2.2 doesn't have 'property'.
def _swig_setattr_nondynamic(self,class_type,name,value,static=1):
    if (name == "thisown"): return self.this.own(value)
    if (name == "this"):
        if type(value).__name__ == 'SwigPyObject':
            self.__dict__[name] = value
            return
    method = class_type.__swig_setmethods__.get(name,None)
    if method: return method(self,value)
    if (not static):
        self.__dict__[name] = value
    else:
        raise AttributeError("You cannot add attributes to %s" % self)

def _swig_setattr(self,class_type,name,value):
    return _swig_setattr_nondynamic(self,class_type,name,value,0)

def _swig_getattr(self,class_type,name):
    if (name == "thisown"): return self.this.own()
    method = class_type.__swig_getmethods__.get(name,None)
    if method: return method(self)
    raise AttributeError(name)

def _swig_repr(self):
    try: strthis = "proxy of " + self.this.__repr__()
    except: strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)

try:
    _object = object
    _newclass = 1
except AttributeError:
    class _object : pass
    _newclass = 0


try:
    import weakref
    weakref_proxy = weakref.proxy
except:
    weakref_proxy = lambda x: x


import PyTrilinos.Teuchos
class AbstractStrategy(_object):
    """Proxy of C++ LOCA::AnasaziOperator::AbstractStrategy class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, AbstractStrategy, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, AbstractStrategy, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """__init__(LOCA::AnasaziOperator::AbstractStrategy self) -> AbstractStrategy"""
        if self.__class__ == AbstractStrategy:
            _self = None
        else:
            _self = self
        this = _AnasaziOperator.new_AbstractStrategy(_self, *args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _AnasaziOperator.delete_AbstractStrategy
    def apply(self, *args):
        """apply(AbstractStrategy self, NOX::Abstract::MultiVector const & input, NOX::Abstract::MultiVector & output)"""
        return _AnasaziOperator.AbstractStrategy_apply(self, *args)

    def preProcessSeedVector(self, *args):
        """preProcessSeedVector(AbstractStrategy self, NOX::Abstract::MultiVector & ivec)"""
        return _AnasaziOperator.AbstractStrategy_preProcessSeedVector(self, *args)

    def beginPostProcessing(self, *args):
        """beginPostProcessing(AbstractStrategy self)"""
        return _AnasaziOperator.AbstractStrategy_beginPostProcessing(self, *args)

    def transformEigenvalue(self, *args):
        """transformEigenvalue(AbstractStrategy self, double & ev_r, double & ev_i)"""
        return _AnasaziOperator.AbstractStrategy_transformEigenvalue(self, *args)

    def rayleighQuotient(self, *args):
        """rayleighQuotient(AbstractStrategy self, NOX::Abstract::Vector & evec_r, NOX::Abstract::Vector & evec_i, double & rq_r, double & rq_i) -> NOX::Abstract::Group::ReturnType"""
        return _AnasaziOperator.AbstractStrategy_rayleighQuotient(self, *args)

    def label(self, *args):
        """label(AbstractStrategy self) -> std::string const"""
        return _AnasaziOperator.AbstractStrategy_label(self, *args)

    def __disown__(self):
        self.this.disown()
        _AnasaziOperator.disown_AbstractStrategy(self)
        return weakref_proxy(self)
AbstractStrategy_swigregister = _AnasaziOperator.AbstractStrategy_swigregister
AbstractStrategy_swigregister(AbstractStrategy)

class Factory(_object):
    """Proxy of C++ LOCA::AnasaziOperator::Factory class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, Factory, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, Factory, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """__init__(LOCA::AnasaziOperator::Factory self, Teuchos::RCP< LOCA::GlobalData > const & global_data) -> Factory"""
        this = _AnasaziOperator.new_Factory(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _AnasaziOperator.delete_Factory
    def create(self, *args):
        """
        create(Factory self, Teuchos::RCP< LOCA::Parameter::SublistParser > const & topParams, Teuchos::RCP< Teuchos::ParameterList > const & eigenParams, 
            Teuchos::RCP< Teuchos::ParameterList > const & solverParams, 
            Teuchos::RCP< NOX::Abstract::Group > const & grp) -> Teuchos::RCP< LOCA::AnasaziOperator::AbstractStrategy >
        """
        return _AnasaziOperator.Factory_create(self, *args)

    def strategyName(self, *args):
        """strategyName(Factory self, ParameterList eigenParams) -> std::string const &"""
        return _AnasaziOperator.Factory_strategyName(self, *args)

Factory_swigregister = _AnasaziOperator.Factory_swigregister
Factory_swigregister(Factory)

# This file is compatible with both classic and new-style classes.


