# This file was automatically generated by SWIG (http://www.swig.org).
# Version 3.0.2
#
# Do not make changes to this file unless you know what you are doing--modify
# the SWIG interface file instead.




"""

PyTrilinos.LOCA.Epetra.Interface is the python interface to namespace
Epetra::Interface of the Trilinos continuation algorithm package LOCA:

    http://trilinos.sandia.gov/packages/nox

The purpose of LOCA.Epetra.Interface is to provide a concrete Epetra
implementation of LOCA interfaces.  The python version of
LOCA.Epetra.Interface supports the following classes:

    * Required                 - Provides a set of interfaces for users to
                                 provide information about the nonlinear
                                 problem to LOCA
    * MassMatrix               - Used by LOCA.Epetra.Group to provide a link
                                 to the external code for the coefficients of
                                 time dependent terms
    * TimeDependent            - Used by LOCA.Epetra.Group to provide a link
                                 to the external code for computing the shifted
                                 matrix
    * TimeDependentMatrixFree  - Used by LOCA.Epetra.Group to provide a link
                                 to the external code for applying the shifted
                                 matrix in a matrix-free setting

"""


from sys import version_info
if version_info >= (2,6,0):
    def swig_import_helper():
        from os.path import dirname
        import imp
        fp = None
        try:
            fp, pathname, description = imp.find_module('_Interface', [dirname(__file__)])
        except ImportError:
            import _Interface
            return _Interface
        if fp is not None:
            try:
                _mod = imp.load_module('_Interface', fp, pathname, description)
            finally:
                fp.close()
            return _mod
    _Interface = swig_import_helper()
    del swig_import_helper
else:
    import _Interface
del version_info
try:
    _swig_property = property
except NameError:
    pass # Python < 2.2 doesn't have 'property'.
def _swig_setattr_nondynamic(self,class_type,name,value,static=1):
    if (name == "thisown"): return self.this.own(value)
    if (name == "this"):
        if type(value).__name__ == 'SwigPyObject':
            self.__dict__[name] = value
            return
    method = class_type.__swig_setmethods__.get(name,None)
    if method: return method(self,value)
    if (not static):
        self.__dict__[name] = value
    else:
        raise AttributeError("You cannot add attributes to %s" % self)

def _swig_setattr(self,class_type,name,value):
    return _swig_setattr_nondynamic(self,class_type,name,value,0)

def _swig_getattr(self,class_type,name):
    if (name == "thisown"): return self.this.own()
    method = class_type.__swig_getmethods__.get(name,None)
    if method: return method(self)
    raise AttributeError(name)

def _swig_repr(self):
    try: strthis = "proxy of " + self.this.__repr__()
    except: strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)

try:
    _object = object
    _newclass = 1
except AttributeError:
    class _object : pass
    _newclass = 0


try:
    import weakref
    weakref_proxy = weakref.proxy
except:
    weakref_proxy = lambda x: x


class SwigPyIterator(_object):
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, SwigPyIterator, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, SwigPyIterator, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Interface.delete_SwigPyIterator
    def value(self): return _Interface.SwigPyIterator_value(self)
    def incr(self, n=1): return _Interface.SwigPyIterator_incr(self, n)
    def decr(self, n=1): return _Interface.SwigPyIterator_decr(self, n)
    def distance(self, *args): return _Interface.SwigPyIterator_distance(self, *args)
    def equal(self, *args): return _Interface.SwigPyIterator_equal(self, *args)
    def copy(self): return _Interface.SwigPyIterator_copy(self)
    def next(self): return _Interface.SwigPyIterator_next(self)
    def __next__(self): return _Interface.SwigPyIterator___next__(self)
    def previous(self): return _Interface.SwigPyIterator_previous(self)
    def advance(self, *args): return _Interface.SwigPyIterator_advance(self, *args)
    def __eq__(self, *args): return _Interface.SwigPyIterator___eq__(self, *args)
    def __ne__(self, *args): return _Interface.SwigPyIterator___ne__(self, *args)
    def __iadd__(self, *args): return _Interface.SwigPyIterator___iadd__(self, *args)
    def __isub__(self, *args): return _Interface.SwigPyIterator___isub__(self, *args)
    def __add__(self, *args): return _Interface.SwigPyIterator___add__(self, *args)
    def __sub__(self, *args): return _Interface.SwigPyIterator___sub__(self, *args)
    def __iter__(self): return self
SwigPyIterator_swigregister = _Interface.SwigPyIterator_swigregister
SwigPyIterator_swigregister(SwigPyIterator)

import PyTrilinos.Teuchos
import PyTrilinos.NOX.Epetra.Interface
import PyTrilinos.Epetra
class Required(PyTrilinos.NOX.Epetra.Interface.Required):
    """Proxy of C++ LOCA::Epetra::Interface::Required class"""
    __swig_setmethods__ = {}
    for _s in [PyTrilinos.NOX.Epetra.Interface.Required]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Required, name, value)
    __swig_getmethods__ = {}
    for _s in [PyTrilinos.NOX.Epetra.Interface.Required]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Required, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """__init__(LOCA::Epetra::Interface::Required self) -> Required"""
        if self.__class__ == Required:
            _self = None
        else:
            _self = self
        this = _Interface.new_Required(_self, *args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Interface.delete_Required
    def setParameters(self, *args):
        """setParameters(Required self, LOCA::ParameterVector const & p)"""
        return _Interface.Required_setParameters(self, *args)

    def printSolution(self, *args):
        """printSolution(Required self, Epetra_Vector x_, double conParam)"""
        return _Interface.Required_printSolution(self, *args)

    def dataForPrintSolution(self, *args):
        """dataForPrintSolution(Required self, int const conStep, int const timeStep, int const totalTimeSteps)"""
        return _Interface.Required_dataForPrintSolution(self, *args)

    def setMultiPointParameter(self, *args):
        """setMultiPointParameter(Required self, int const stepNum)"""
        return _Interface.Required_setMultiPointParameter(self, *args)

    def preProcessContinuationStep(self, *args):
        """preProcessContinuationStep(Required self, LOCA::Abstract::Iterator::StepStatus stepStatus, LOCA::Epetra::Group & group)"""
        return _Interface.Required_preProcessContinuationStep(self, *args)

    def postProcessContinuationStep(self, *args):
        """postProcessContinuationStep(Required self, LOCA::Abstract::Iterator::StepStatus stepStatus, LOCA::Epetra::Group & group)"""
        return _Interface.Required_postProcessContinuationStep(self, *args)

    def projectToDraw(self, *args):
        """projectToDraw(Required self, Vector x, double * px)"""
        return _Interface.Required_projectToDraw(self, *args)

    def projectToDrawDimension(self, *args):
        """projectToDrawDimension(Required self) -> int"""
        return _Interface.Required_projectToDrawDimension(self, *args)

    def __disown__(self):
        self.this.disown()
        _Interface.disown_Required(self)
        return weakref_proxy(self)
Required_swigregister = _Interface.Required_swigregister
Required_swigregister(Required)

class MassMatrix(_object):
    """Proxy of C++ LOCA::Epetra::Interface::MassMatrix class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, MassMatrix, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, MassMatrix, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """__init__(LOCA::Epetra::Interface::MassMatrix self) -> MassMatrix"""
        if self.__class__ == MassMatrix:
            _self = None
        else:
            _self = self
        this = _Interface.new_MassMatrix(_self, *args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Interface.delete_MassMatrix
    def computeMassMatrix(self, *args):
        """computeMassMatrix(MassMatrix self, Epetra_Vector x) -> bool"""
        return _Interface.MassMatrix_computeMassMatrix(self, *args)

    def setOldSolution(self, *args):
        """setOldSolution(MassMatrix self, Epetra_Vector x, int const timeStep)"""
        return _Interface.MassMatrix_setOldSolution(self, *args)

    def setOldSolutionFirstStep(self, *args):
        """setOldSolutionFirstStep(MassMatrix self)"""
        return _Interface.MassMatrix_setOldSolutionFirstStep(self, *args)

    def dataForPrintSolution(self, *args):
        """dataForPrintSolution(MassMatrix self, int const conStep, int const timeStep, int const totalTimeSteps)"""
        return _Interface.MassMatrix_dataForPrintSolution(self, *args)

    def __disown__(self):
        self.this.disown()
        _Interface.disown_MassMatrix(self)
        return weakref_proxy(self)
MassMatrix_swigregister = _Interface.MassMatrix_swigregister
MassMatrix_swigregister(MassMatrix)

class TimeDependent(Required):
    """Proxy of C++ LOCA::Epetra::Interface::TimeDependent class"""
    __swig_setmethods__ = {}
    for _s in [Required]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, TimeDependent, name, value)
    __swig_getmethods__ = {}
    for _s in [Required]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, TimeDependent, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """__init__(LOCA::Epetra::Interface::TimeDependent self) -> TimeDependent"""
        if self.__class__ == TimeDependent:
            _self = None
        else:
            _self = self
        this = _Interface.new_TimeDependent(_self, *args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Interface.delete_TimeDependent
    def computeShiftedMatrix(self, *args):
        """computeShiftedMatrix(TimeDependent self, double alpha, double beta, Epetra_Vector x, Operator A) -> bool"""
        return _Interface.TimeDependent_computeShiftedMatrix(self, *args)

    def setXdot(self, *args):
        """setXdot(TimeDependent self, Epetra_Vector xdot, double const time)"""
        return _Interface.TimeDependent_setXdot(self, *args)

    def __disown__(self):
        self.this.disown()
        _Interface.disown_TimeDependent(self)
        return weakref_proxy(self)
TimeDependent_swigregister = _Interface.TimeDependent_swigregister
TimeDependent_swigregister(TimeDependent)

class TimeDependentMatrixFree(Required):
    """Proxy of C++ LOCA::Epetra::Interface::TimeDependentMatrixFree class"""
    __swig_setmethods__ = {}
    for _s in [Required]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, TimeDependentMatrixFree, name, value)
    __swig_getmethods__ = {}
    for _s in [Required]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, TimeDependentMatrixFree, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """__init__(LOCA::Epetra::Interface::TimeDependentMatrixFree self) -> TimeDependentMatrixFree"""
        if self.__class__ == TimeDependentMatrixFree:
            _self = None
        else:
            _self = self
        this = _Interface.new_TimeDependentMatrixFree(_self, *args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Interface.delete_TimeDependentMatrixFree
    def applyShiftedMatrix(self, *args):
        """applyShiftedMatrix(TimeDependentMatrixFree self, double alpha, double beta, Vector input, Vector loca_result) -> bool"""
        return _Interface.TimeDependentMatrixFree_applyShiftedMatrix(self, *args)

    def __disown__(self):
        self.this.disown()
        _Interface.disown_TimeDependentMatrixFree(self)
        return weakref_proxy(self)
TimeDependentMatrixFree_swigregister = _Interface.TimeDependentMatrixFree_swigregister
TimeDependentMatrixFree_swigregister(TimeDependentMatrixFree)

# This file is compatible with both classic and new-style classes.


