# This file was automatically generated by SWIG (http://www.swig.org).
# Version 3.0.2
#
# Do not make changes to this file unless you know what you are doing--modify
# the SWIG interface file instead.




"""

PyTrilinos.LOCA.Extended is the python interface to namespace Extended
of the Trilinos continuation algorithm package LOCA:

    http://trilinos.sandia.gov/packages/nox

The purpose of LOCA.Extended is to provide classes that extend
NOX.Abstract classes to handle an arbitrary number of multi-vectors
and scalars.  The python version of LOCA.Extended supports the
following classes:

    * MultiVector         - Implemenatation of the NOX.Abstract.MultiVector
                            class for extended multi-vectors comprised of an
                            arbitrary number of multi-vectors and scalars
    * Vector              - Implemenatation of the NOX.Abstract.Vector class
                            for extended multi-vectors comprised of an
                            arbitrary number of multi-vectors and scalars
    * MultiAbstractGroup  - LOCA abstract interface for extended groups,
                            derived from the NOX.Abstract.Group, i.e., an
                            abstract interface for 'super' groups that have an
                            underlying group component

"""


from sys import version_info
if version_info >= (2,6,0):
    def swig_import_helper():
        from os.path import dirname
        import imp
        fp = None
        try:
            fp, pathname, description = imp.find_module('_Extended', [dirname(__file__)])
        except ImportError:
            import _Extended
            return _Extended
        if fp is not None:
            try:
                _mod = imp.load_module('_Extended', fp, pathname, description)
            finally:
                fp.close()
            return _mod
    _Extended = swig_import_helper()
    del swig_import_helper
else:
    import _Extended
del version_info
try:
    _swig_property = property
except NameError:
    pass # Python < 2.2 doesn't have 'property'.
def _swig_setattr_nondynamic(self,class_type,name,value,static=1):
    if (name == "thisown"): return self.this.own(value)
    if (name == "this"):
        if type(value).__name__ == 'SwigPyObject':
            self.__dict__[name] = value
            return
    method = class_type.__swig_setmethods__.get(name,None)
    if method: return method(self,value)
    if (not static):
        self.__dict__[name] = value
    else:
        raise AttributeError("You cannot add attributes to %s" % self)

def _swig_setattr(self,class_type,name,value):
    return _swig_setattr_nondynamic(self,class_type,name,value,0)

def _swig_getattr(self,class_type,name):
    if (name == "thisown"): return self.this.own()
    method = class_type.__swig_getmethods__.get(name,None)
    if method: return method(self)
    raise AttributeError(name)

def _swig_repr(self):
    try: strthis = "proxy of " + self.this.__repr__()
    except: strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)

try:
    _object = object
    _newclass = 1
except AttributeError:
    class _object : pass
    _newclass = 0


try:
    import weakref
    weakref_proxy = weakref.proxy
except:
    weakref_proxy = lambda x: x


import PyTrilinos.Teuchos
import PyTrilinos.NOX.Abstract
class MultiVector(PyTrilinos.NOX.Abstract.MultiVector):
    """Proxy of C++ LOCA::Extended::MultiVector class"""
    __swig_setmethods__ = {}
    for _s in [PyTrilinos.NOX.Abstract.MultiVector]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, MultiVector, name, value)
    __swig_getmethods__ = {}
    for _s in [PyTrilinos.NOX.Abstract.MultiVector]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, MultiVector, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(LOCA::Extended::MultiVector self, MultiVector source, NOX::CopyType type=DeepCopy) -> MultiVector
        __init__(LOCA::Extended::MultiVector self, MultiVector source, int nColumns) -> MultiVector
        __init__(LOCA::Extended::MultiVector self, MultiVector source, std::vector< int,std::allocator< int > > const & index, bool view) -> MultiVector
        """
        this = _Extended.new_MultiVector(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Extended.delete_MultiVector
    def init(self, *args):
        """init(MultiVector self, double gamma) -> MultiVector"""
        return _Extended.MultiVector_init(self, *args)

    def random(self, *args):
        """random(MultiVector self, bool useSeed=False, int seed=1) -> MultiVector"""
        return _Extended.MultiVector_random(self, *args)

    def setBlock(self, *args):
        """
        setBlock(MultiVector self, MultiVector source, std::vector< int,std::allocator< int > > const & index) -> MultiVector
        setBlock(MultiVector self, MultiVector source, std::vector< int,std::allocator< int > > const & index) -> MultiVector
        """
        return _Extended.MultiVector_setBlock(self, *args)

    def augment(self, *args):
        """
        augment(MultiVector self, MultiVector source) -> MultiVector
        augment(MultiVector self, MultiVector source) -> MultiVector
        """
        return _Extended.MultiVector_augment(self, *args)

    def scale(self, *args):
        """scale(MultiVector self, double gamma) -> MultiVector"""
        return _Extended.MultiVector_scale(self, *args)

    def update(self, *args):
        """
        update(MultiVector self, double alpha, MultiVector a, double gamma=0.0) -> MultiVector
        update(MultiVector self, double alpha, MultiVector a, double gamma=0.0) -> MultiVector
        update(MultiVector self, double alpha, MultiVector a, double beta, MultiVector b, double gamma=0.0) -> MultiVector
        update(MultiVector self, double alpha, MultiVector a, double beta, MultiVector b, double gamma=0.0) -> MultiVector
        update(MultiVector self, Teuchos::ETransp transb, double alpha, MultiVector a, NOX::Abstract::MultiVector::DenseMatrix const & b, 
            double gamma=0.0) -> MultiVector
        update(MultiVector self, Teuchos::ETransp transb, double alpha, MultiVector a, NOX::Abstract::MultiVector::DenseMatrix const & b, 
            double gamma=0.0) -> MultiVector
        """
        return _Extended.MultiVector_update(self, *args)

    def clone(self, *args):
        """clone(MultiVector self, NOX::CopyType type=DeepCopy) -> Teuchos::RCP< NOX::Abstract::MultiVector >"""
        return _Extended.MultiVector_clone(self, *args)

    def subCopy(self, *args):
        """subCopy(MultiVector self, std::vector< int,std::allocator< int > > const & index) -> Teuchos::RCP< NOX::Abstract::MultiVector >"""
        return _Extended.MultiVector_subCopy(self, *args)

    def subView(self, *args):
        """subView(MultiVector self, std::vector< int,std::allocator< int > > const & index) -> Teuchos::RCP< NOX::Abstract::MultiVector >"""
        return _Extended.MultiVector_subView(self, *args)

    def norm(self, *args):
        """norm(MultiVector self, std::vector< double,std::allocator< double > > & result, NOX::Abstract::Vector::NormType type=TwoNorm)"""
        return _Extended.MultiVector_norm(self, *args)

    def multiply(self, *args):
        """
        multiply(MultiVector self, double alpha, MultiVector y, NOX::Abstract::MultiVector::DenseMatrix & b)
        multiply(MultiVector self, double alpha, MultiVector y, NOX::Abstract::MultiVector::DenseMatrix & b)
        """
        return _Extended.MultiVector_multiply(self, *args)

    def length(self, *args):
        """length(MultiVector self) -> NOX::size_type"""
        return _Extended.MultiVector_length(self, *args)

    def numVectors(self, *args):
        """numVectors(MultiVector self) -> int"""
        return _Extended.MultiVector_numVectors(self, *args)

    def _print(self, *args):
        """_print(MultiVector self, std::ostream & stream)"""
        return _Extended.MultiVector__print(self, *args)

    def getMultiVector(self, *args):
        """
        getMultiVector(MultiVector self, int i) -> Teuchos::RCP< NOX::Abstract::MultiVector const >
        getMultiVector(MultiVector self, int i) -> Teuchos::RCP< NOX::Abstract::MultiVector >
        """
        return _Extended.MultiVector_getMultiVector(self, *args)

    def getScalars(self, *args):
        """
        getScalars(MultiVector self) -> Teuchos::RCP< NOX::Abstract::MultiVector::DenseMatrix const >
        getScalars(MultiVector self) -> Teuchos::RCP< NOX::Abstract::MultiVector::DenseMatrix >
        """
        return _Extended.MultiVector_getScalars(self, *args)

    def getScalarRows(self, *args):
        """
        getScalarRows(MultiVector self, int num_rows, int row) -> Teuchos::RCP< NOX::Abstract::MultiVector::DenseMatrix const >
        getScalarRows(MultiVector self, int num_rows, int row) -> Teuchos::RCP< NOX::Abstract::MultiVector::DenseMatrix >
        """
        return _Extended.MultiVector_getScalarRows(self, *args)

    def getScalar(self, *args):
        """
        getScalar(MultiVector self, int i, int j) -> double const
        getScalar(MultiVector self, int i, int j) -> double &
        """
        return _Extended.MultiVector_getScalar(self, *args)

    def getVector(self, *args):
        """
        getVector(MultiVector self, int i) -> Teuchos::RCP< LOCA::Extended::Vector >
        getVector(MultiVector self, int i) -> Teuchos::RCP< LOCA::Extended::Vector const >
        """
        return _Extended.MultiVector_getVector(self, *args)

    def getNumScalarRows(self, *args):
        """getNumScalarRows(MultiVector self) -> int"""
        return _Extended.MultiVector_getNumScalarRows(self, *args)

    def getNumMultiVectors(self, *args):
        """getNumMultiVectors(MultiVector self) -> int"""
        return _Extended.MultiVector_getNumMultiVectors(self, *args)

MultiVector_swigregister = _Extended.MultiVector_swigregister
MultiVector_swigregister(MultiVector)

class Vector(PyTrilinos.NOX.Abstract.Vector):
    """Proxy of C++ LOCA::Extended::Vector class"""
    __swig_setmethods__ = {}
    for _s in [PyTrilinos.NOX.Abstract.Vector]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Vector, name, value)
    __swig_getmethods__ = {}
    for _s in [PyTrilinos.NOX.Abstract.Vector]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Vector, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """__init__(LOCA::Extended::Vector self, Vector source, NOX::CopyType type=DeepCopy) -> Vector"""
        this = _Extended.new_Vector(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Extended.delete_Vector
    def clone(self, *args):
        """clone(Vector self, NOX::CopyType type=DeepCopy) -> Teuchos::RCP< NOX::Abstract::Vector >"""
        return _Extended.Vector_clone(self, *args)

    def createMultiVector(self, *args):
        """
        createMultiVector(Vector self, NOX::Abstract::Vector const *const * vecs, int numVecs, NOX::CopyType type=DeepCopy) -> Teuchos::RCP< NOX::Abstract::MultiVector >
        createMultiVector(Vector self, int numVecs, NOX::CopyType type=DeepCopy) -> Teuchos::RCP< NOX::Abstract::MultiVector >
        """
        return _Extended.Vector_createMultiVector(self, *args)

    def init(self, *args):
        """init(Vector self, double gamma) -> Vector"""
        return _Extended.Vector_init(self, *args)

    def random(self, *args):
        """random(Vector self, bool useSeed=False, int seed=1) -> Vector"""
        return _Extended.Vector_random(self, *args)

    def abs(self, *args):
        """abs(Vector self, Vector y) -> Vector"""
        return _Extended.Vector_abs(self, *args)

    def reciprocal(self, *args):
        """reciprocal(Vector self, Vector y) -> Vector"""
        return _Extended.Vector_reciprocal(self, *args)

    def scale(self, *args):
        """
        scale(Vector self, double gamma) -> Vector
        scale(Vector self, Vector a) -> Vector
        """
        return _Extended.Vector_scale(self, *args)

    def update(self, *args):
        """
        update(Vector self, double alpha, Vector a, double gamma=0.0) -> Vector
        update(Vector self, double alpha, Vector a, double beta, Vector b, double gamma=0.0) -> Vector
        """
        return _Extended.Vector_update(self, *args)

    def norm(self, *args):
        """
        norm(Vector self, NOX::Abstract::Vector::NormType type=TwoNorm) -> double
        norm(Vector self, Vector weights) -> double
        """
        return _Extended.Vector_norm(self, *args)

    def innerProduct(self, *args):
        """innerProduct(Vector self, Vector y) -> double"""
        return _Extended.Vector_innerProduct(self, *args)

    def length(self, *args):
        """length(Vector self) -> NOX::size_type"""
        return _Extended.Vector_length(self, *args)

    def _print(self, *args):
        """_print(Vector self, std::ostream & stream)"""
        return _Extended.Vector__print(self, *args)

    def setVector(self, *args):
        """setVector(Vector self, int i, Vector v)"""
        return _Extended.Vector_setVector(self, *args)

    def setVectorView(self, *args):
        """setVectorView(Vector self, int i, Teuchos::RCP< NOX::Abstract::Vector > const & v)"""
        return _Extended.Vector_setVectorView(self, *args)

    def setScalar(self, *args):
        """setScalar(Vector self, int i, double s)"""
        return _Extended.Vector_setScalar(self, *args)

    def setScalarArray(self, *args):
        """setScalarArray(Vector self, double * sv)"""
        return _Extended.Vector_setScalarArray(self, *args)

    def getVector(self, *args):
        """
        getVector(Vector self, int i) -> Teuchos::RCP< NOX::Abstract::Vector const >
        getVector(Vector self, int i) -> Teuchos::RCP< NOX::Abstract::Vector >
        """
        return _Extended.Vector_getVector(self, *args)

    def getScalar(self, *args):
        """getScalar(Vector self, int i) -> double"""
        return _Extended.Vector_getScalar(self, *args)

    def getScalars(self, *args):
        """
        getScalars(Vector self) -> Teuchos::RCP< NOX::Abstract::MultiVector::DenseMatrix const >
        getScalars(Vector self) -> Teuchos::RCP< NOX::Abstract::MultiVector::DenseMatrix >
        """
        return _Extended.Vector_getScalars(self, *args)

    def getNumScalars(self, *args):
        """getNumScalars(Vector self) -> int"""
        return _Extended.Vector_getNumScalars(self, *args)

    def getNumVectors(self, *args):
        """getNumVectors(Vector self) -> int"""
        return _Extended.Vector_getNumVectors(self, *args)

Vector_swigregister = _Extended.Vector_swigregister
Vector_swigregister(Vector)

class MultiAbstractGroup(PyTrilinos.NOX.Abstract.Group):
    """Proxy of C++ LOCA::Extended::MultiAbstractGroup class"""
    __swig_setmethods__ = {}
    for _s in [PyTrilinos.NOX.Abstract.Group]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, MultiAbstractGroup, name, value)
    __swig_getmethods__ = {}
    for _s in [PyTrilinos.NOX.Abstract.Group]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, MultiAbstractGroup, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Extended.delete_MultiAbstractGroup
    def getUnderlyingGroup(self, *args):
        """
        getUnderlyingGroup(MultiAbstractGroup self) -> Teuchos::RCP< LOCA::MultiContinuation::AbstractGroup const >
        getUnderlyingGroup(MultiAbstractGroup self) -> Teuchos::RCP< LOCA::MultiContinuation::AbstractGroup >
        """
        return _Extended.MultiAbstractGroup_getUnderlyingGroup(self, *args)

    def getBaseLevelUnderlyingGroup(self, *args):
        """
        getBaseLevelUnderlyingGroup(MultiAbstractGroup self) -> Teuchos::RCP< LOCA::MultiContinuation::AbstractGroup const >
        getBaseLevelUnderlyingGroup(MultiAbstractGroup self) -> Teuchos::RCP< LOCA::MultiContinuation::AbstractGroup >
        """
        return _Extended.MultiAbstractGroup_getBaseLevelUnderlyingGroup(self, *args)

MultiAbstractGroup_swigregister = _Extended.MultiAbstractGroup_swigregister
MultiAbstractGroup_swigregister(MultiAbstractGroup)

# This file is compatible with both classic and new-style classes.


