# This file was automatically generated by SWIG (http://www.swig.org).
# Version 3.0.2
#
# Do not make changes to this file unless you know what you are doing--modify
# the SWIG interface file instead.




"""

PyTrilinos.LOCA.Parameter is the python interface to namespace
Parameter of the Trilinos continuation algorithm package LOCA:

    http://trilinos.sandia.gov/packages/nox

The purpose of LOCA.Parameter is to provide a centralized library for
setting/retrieving numerical parameter values in application codes.
The python version of LOCA.Parameter supports the following classes:

    * Library  - Class to provide a centralized library for setting/retrieving
                 numerical parameter values in application codes

"""


from sys import version_info
if version_info >= (2,6,0):
    def swig_import_helper():
        from os.path import dirname
        import imp
        fp = None
        try:
            fp, pathname, description = imp.find_module('_Parameter', [dirname(__file__)])
        except ImportError:
            import _Parameter
            return _Parameter
        if fp is not None:
            try:
                _mod = imp.load_module('_Parameter', fp, pathname, description)
            finally:
                fp.close()
            return _mod
    _Parameter = swig_import_helper()
    del swig_import_helper
else:
    import _Parameter
del version_info
try:
    _swig_property = property
except NameError:
    pass # Python < 2.2 doesn't have 'property'.
def _swig_setattr_nondynamic(self,class_type,name,value,static=1):
    if (name == "thisown"): return self.this.own(value)
    if (name == "this"):
        if type(value).__name__ == 'SwigPyObject':
            self.__dict__[name] = value
            return
    method = class_type.__swig_setmethods__.get(name,None)
    if method: return method(self,value)
    if (not static):
        self.__dict__[name] = value
    else:
        raise AttributeError("You cannot add attributes to %s" % self)

def _swig_setattr(self,class_type,name,value):
    return _swig_setattr_nondynamic(self,class_type,name,value,0)

def _swig_getattr(self,class_type,name):
    if (name == "thisown"): return self.this.own()
    method = class_type.__swig_getmethods__.get(name,None)
    if method: return method(self)
    raise AttributeError(name)

def _swig_repr(self):
    try: strthis = "proxy of " + self.this.__repr__()
    except: strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)

try:
    _object = object
    _newclass = 1
except AttributeError:
    class _object : pass
    _newclass = 0


try:
    import weakref
    weakref_proxy = weakref.proxy
except:
    weakref_proxy = lambda x: x


import PyTrilinos.Teuchos
class Library(_object):
    """Proxy of C++ LOCA::Parameter::Library class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, Library, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, Library, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """__init__(LOCA::Parameter::Library self) -> Library"""
        this = _Parameter.new_Library(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Parameter.delete_Library
Library_swigregister = _Parameter.Library_swigregister
Library_swigregister(Library)

class ParameterVector(_object):
    """Proxy of C++ LOCA::ParameterVector class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, ParameterVector, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, ParameterVector, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(LOCA::ParameterVector self) -> ParameterVector
        __init__(LOCA::ParameterVector self, ParameterVector source) -> ParameterVector
        """
        this = _Parameter.new_ParameterVector(*args)
        try: self.this.append(this)
        except: self.this = this
    def clone(self, *args):
        """clone(ParameterVector self) -> ParameterVector"""
        return _Parameter.ParameterVector_clone(self, *args)

    __swig_destroy__ = _Parameter.delete_ParameterVector
    def addParameter(self, *args):
        """addParameter(ParameterVector self, std::string label, double value=0.0) -> int"""
        return _Parameter.ParameterVector_addParameter(self, *args)

    def init(self, *args):
        """init(ParameterVector self, double value) -> bool"""
        return _Parameter.ParameterVector_init(self, *args)

    def scale(self, *args):
        """
        scale(ParameterVector self, double value) -> bool
        scale(ParameterVector self, ParameterVector p) -> bool
        """
        return _Parameter.ParameterVector_scale(self, *args)

    def update(self, *args):
        """update(ParameterVector self, double alpha, ParameterVector alphaVector, double b) -> bool"""
        return _Parameter.ParameterVector_update(self, *args)

    def setValue(self, *args):
        """
        setValue(ParameterVector self, unsigned int i, double value)
        setValue(ParameterVector self, std::string label, double value)
        """
        return _Parameter.ParameterVector_setValue(self, *args)

    def getValue(self, *args):
        """
        getValue(ParameterVector self, unsigned int i) -> double
        getValue(ParameterVector self, std::string label) -> double
        """
        return _Parameter.ParameterVector_getValue(self, *args)

    def getIndex(self, *args):
        """getIndex(ParameterVector self, std::string label) -> int"""
        return _Parameter.ParameterVector_getIndex(self, *args)

    def getDoubleArrayPointer(self, *args):
        """getDoubleArrayPointer(ParameterVector self) -> double *"""
        return _Parameter.ParameterVector_getDoubleArrayPointer(self, *args)

    def isParameter(self, *args):
        """isParameter(ParameterVector self, std::string label) -> bool"""
        return _Parameter.ParameterVector_isParameter(self, *args)

    def getLabel(self, *args):
        """getLabel(ParameterVector self, unsigned int i) -> std::string"""
        return _Parameter.ParameterVector_getLabel(self, *args)

    def length(self, *args):
        """length(ParameterVector self) -> int"""
        return _Parameter.ParameterVector_length(self, *args)

    def getValuesVector(self, *args):
        """getValuesVector(ParameterVector self) -> std::vector< double,std::allocator< double > > const &"""
        return _Parameter.ParameterVector_getValuesVector(self, *args)

    def getNamesVector(self, *args):
        """getNamesVector(ParameterVector self) -> std::vector< std::string,std::allocator< std::string > > const &"""
        return _Parameter.ParameterVector_getNamesVector(self, *args)

ParameterVector_swigregister = _Parameter.ParameterVector_swigregister
ParameterVector_swigregister(ParameterVector)


def __lshift__(*args):
  """__lshift__(std::ostream & stream, ParameterVector p) -> std::ostream &"""
  return _Parameter.__lshift__(*args)
# This file is compatible with both classic and new-style classes.


