# This file was automatically generated by SWIG (http://www.swig.org).
# Version 3.0.2
#
# Do not make changes to this file unless you know what you are doing--modify
# the SWIG interface file instead.




"""

PyTrilinos.LOCA.StatusTest is the python interface to namespace *** of
the Trilinos continuation algorithm package LOCA:

    http://trilinos.sandia.gov/packages/nox

The purpose of LOCA.StatusTest is to provide status checkers.  The
python version of LOCA.StatusTest supports the following classes:

    * Abstract  - Generic status test to check for convergence or failure of
                  the LOCA continuation
    * Wrapper   - A wrapper class for wrapping a NOX status test

"""


from sys import version_info
if version_info >= (2,6,0):
    def swig_import_helper():
        from os.path import dirname
        import imp
        fp = None
        try:
            fp, pathname, description = imp.find_module('_StatusTest', [dirname(__file__)])
        except ImportError:
            import _StatusTest
            return _StatusTest
        if fp is not None:
            try:
                _mod = imp.load_module('_StatusTest', fp, pathname, description)
            finally:
                fp.close()
            return _mod
    _StatusTest = swig_import_helper()
    del swig_import_helper
else:
    import _StatusTest
del version_info
try:
    _swig_property = property
except NameError:
    pass # Python < 2.2 doesn't have 'property'.
def _swig_setattr_nondynamic(self,class_type,name,value,static=1):
    if (name == "thisown"): return self.this.own(value)
    if (name == "this"):
        if type(value).__name__ == 'SwigPyObject':
            self.__dict__[name] = value
            return
    method = class_type.__swig_setmethods__.get(name,None)
    if method: return method(self,value)
    if (not static):
        self.__dict__[name] = value
    else:
        raise AttributeError("You cannot add attributes to %s" % self)

def _swig_setattr(self,class_type,name,value):
    return _swig_setattr_nondynamic(self,class_type,name,value,0)

def _swig_getattr(self,class_type,name):
    if (name == "thisown"): return self.this.own()
    method = class_type.__swig_getmethods__.get(name,None)
    if method: return method(self)
    raise AttributeError(name)

def _swig_repr(self):
    try: strthis = "proxy of " + self.this.__repr__()
    except: strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)

try:
    _object = object
    _newclass = 1
except AttributeError:
    class _object : pass
    _newclass = 0


try:
    import weakref
    weakref_proxy = weakref.proxy
except:
    weakref_proxy = lambda x: x


import PyTrilinos.Teuchos
import PyTrilinos.NOX.StatusTest
Finished = _StatusTest.Finished
Failed = _StatusTest.Failed
NotFinished = _StatusTest.NotFinished
Unevaluated = _StatusTest.Unevaluated
Complete = _StatusTest.Complete
Minimal = _StatusTest.Minimal
None_ = _StatusTest.None_
class Abstract(_object):
    """Proxy of C++ LOCA::StatusTest::Abstract class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, Abstract, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, Abstract, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """__init__(LOCA::StatusTest::Abstract self) -> Abstract"""
        if self.__class__ == Abstract:
            _self = None
        else:
            _self = self
        this = _StatusTest.new_Abstract(_self, *args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _StatusTest.delete_Abstract
    def checkStatus(self, *args):
        """checkStatus(Abstract self, LOCA::Abstract::Iterator const & stepper, LOCA::StatusTest::CheckType checkType) -> LOCA::StatusTest::StatusType"""
        return _StatusTest.Abstract_checkStatus(self, *args)

    def getStatus(self, *args):
        """getStatus(Abstract self) -> LOCA::StatusTest::StatusType"""
        return _StatusTest.Abstract_getStatus(self, *args)

    def __disown__(self):
        self.this.disown()
        _StatusTest.disown_Abstract(self)
        return weakref_proxy(self)
Abstract_swigregister = _StatusTest.Abstract_swigregister
Abstract_swigregister(Abstract)


def __lshift__(*args):
  """__lshift__(std::ostream & os, LOCA::StatusTest::StatusType status) -> std::ostream &"""
  return _StatusTest.__lshift__(*args)
class Wrapper(PyTrilinos.NOX.StatusTest.Generic):
    """Proxy of C++ LOCA::StatusTest::Wrapper class"""
    __swig_setmethods__ = {}
    for _s in [PyTrilinos.NOX.StatusTest.Generic]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Wrapper, name, value)
    __swig_getmethods__ = {}
    for _s in [PyTrilinos.NOX.StatusTest.Generic]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Wrapper, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """__init__(LOCA::StatusTest::Wrapper self, Teuchos::RCP< NOX::StatusTest::Generic > const & s) -> Wrapper"""
        if self.__class__ == Wrapper:
            _self = None
        else:
            _self = self
        this = _StatusTest.new_Wrapper(_self, *args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _StatusTest.delete_Wrapper
    def checkStatus(self, *args):
        """checkStatus(Wrapper self, NOX::Solver::Generic const & problem, NOX::StatusTest::CheckType checkType) -> NOX::StatusTest::StatusType"""
        return _StatusTest.Wrapper_checkStatus(self, *args)

    def getStatus(self, *args):
        """getStatus(Wrapper self) -> NOX::StatusTest::StatusType"""
        return _StatusTest.Wrapper_getStatus(self, *args)

    def getUnderlyingStatusTest(self, *args):
        """
        getUnderlyingStatusTest(Wrapper self) -> Teuchos::RCP< NOX::StatusTest::Generic >
        getUnderlyingStatusTest(Wrapper self) -> Teuchos::RCP< NOX::StatusTest::Generic const >
        """
        return _StatusTest.Wrapper_getUnderlyingStatusTest(self, *args)

    def __disown__(self):
        self.this.disown()
        _StatusTest.disown_Wrapper(self)
        return weakref_proxy(self)
Wrapper_swigregister = _StatusTest.Wrapper_swigregister
Wrapper_swigregister(Wrapper)

# This file is compatible with both classic and new-style classes.


