# This file was automatically generated by SWIG (http://www.swig.org).
# Version 3.0.2
#
# Do not make changes to this file unless you know what you are doing--modify
# the SWIG interface file instead.




"""

PyTrilinos.LOCA.TurningPoint.MooreSpence is the python interface to
namespace TurningPoint::MooreSpence of the Trilinos continuation
algorithm package LOCA:

    http://trilinos.sandia.gov/packages/nox

The purpose of LOCA.TurningPoint.MooreSpence is to provide groups and
vectors for locating turning point bifurcations using the Moore-
Spence formulation.  The python version of
LOCA.TurningPoint.MooreSpence supports the following classes:

    * AbstractGroup          - Interface to underlying groups for turning point
                               calculations using the Moore-Spence formulation
    * FiniteDifferenceGroup  - Concrete class that provides concrete
                               implementations of the derivative computation
                               methods of the LOCA.TurningPoint.MooreSpence.-
                               AbstractGroup using first-order finite
                               differencing
    * SolverFactory          - Factory for creating solver objects for solving
                               Moore-Spence turning point equations

"""


from sys import version_info
if version_info >= (2,6,0):
    def swig_import_helper():
        from os.path import dirname
        import imp
        fp = None
        try:
            fp, pathname, description = imp.find_module('_MooreSpence', [dirname(__file__)])
        except ImportError:
            import _MooreSpence
            return _MooreSpence
        if fp is not None:
            try:
                _mod = imp.load_module('_MooreSpence', fp, pathname, description)
            finally:
                fp.close()
            return _mod
    _MooreSpence = swig_import_helper()
    del swig_import_helper
else:
    import _MooreSpence
del version_info
try:
    _swig_property = property
except NameError:
    pass # Python < 2.2 doesn't have 'property'.
def _swig_setattr_nondynamic(self,class_type,name,value,static=1):
    if (name == "thisown"): return self.this.own(value)
    if (name == "this"):
        if type(value).__name__ == 'SwigPyObject':
            self.__dict__[name] = value
            return
    method = class_type.__swig_setmethods__.get(name,None)
    if method: return method(self,value)
    if (not static):
        self.__dict__[name] = value
    else:
        raise AttributeError("You cannot add attributes to %s" % self)

def _swig_setattr(self,class_type,name,value):
    return _swig_setattr_nondynamic(self,class_type,name,value,0)

def _swig_getattr(self,class_type,name):
    if (name == "thisown"): return self.this.own()
    method = class_type.__swig_getmethods__.get(name,None)
    if method: return method(self)
    raise AttributeError(name)

def _swig_repr(self):
    try: strthis = "proxy of " + self.this.__repr__()
    except: strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)

try:
    _object = object
    _newclass = 1
except AttributeError:
    class _object : pass
    _newclass = 0


try:
    import weakref
    weakref_proxy = weakref.proxy
except:
    weakref_proxy = lambda x: x


import PyTrilinos.Teuchos
import sys, os.path as op
parentDir = op.normpath(op.join(op.dirname(op.abspath(__file__)),".."))
if not parentDir in sys.path: sys.path.append(parentDir)
del sys, op

import PyTrilinos.NOX.Abstract
import MultiContinuation
import PyTrilinos.LOCA.Parameter
class AbstractGroup(MultiContinuation.AbstractGroup):
    """Proxy of C++ LOCA::TurningPoint::MooreSpence::AbstractGroup class"""
    __swig_setmethods__ = {}
    for _s in [MultiContinuation.AbstractGroup]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, AbstractGroup, name, value)
    __swig_getmethods__ = {}
    for _s in [MultiContinuation.AbstractGroup]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, AbstractGroup, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _MooreSpence.delete_AbstractGroup
    def computeDJnDpMulti(self, *args):
        """
        computeDJnDpMulti(AbstractGroup self, std::vector< int,std::allocator< int > > const & paramIDs, Vector nullVector, MultiVector result, 
            bool isValid) -> NOX::Abstract::Group::ReturnType
        """
        return _MooreSpence.AbstractGroup_computeDJnDpMulti(self, *args)

    def computeDJnDxaMulti(self, *args):
        """
        computeDJnDxaMulti(AbstractGroup self, Vector nullVector, MultiVector aVector, MultiVector result) -> NOX::Abstract::Group::ReturnType
        computeDJnDxaMulti(AbstractGroup self, Vector nullVector, Vector JnVector, MultiVector aVector, MultiVector result) -> NOX::Abstract::Group::ReturnType
        """
        return _MooreSpence.AbstractGroup_computeDJnDxaMulti(self, *args)

    def computeDwtJnDxMulti(self, *args):
        """computeDwtJnDxMulti(AbstractGroup self, MultiVector w, Vector nullVector, MultiVector result) -> NOX::Abstract::Group::ReturnType"""
        return _MooreSpence.AbstractGroup_computeDwtJnDxMulti(self, *args)

AbstractGroup_swigregister = _MooreSpence.AbstractGroup_swigregister
AbstractGroup_swigregister(AbstractGroup)

class FiniteDifferenceGroup(AbstractGroup,MultiContinuation.FiniteDifferenceGroup):
    """Proxy of C++ LOCA::TurningPoint::MooreSpence::FiniteDifferenceGroup class"""
    __swig_setmethods__ = {}
    for _s in [AbstractGroup,MultiContinuation.FiniteDifferenceGroup]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, FiniteDifferenceGroup, name, value)
    __swig_getmethods__ = {}
    for _s in [AbstractGroup,MultiContinuation.FiniteDifferenceGroup]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, FiniteDifferenceGroup, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _MooreSpence.delete_FiniteDifferenceGroup
    def computeDJnDpMulti(self, *args):
        """
        computeDJnDpMulti(FiniteDifferenceGroup self, std::vector< int,std::allocator< int > > const & paramIDs, Vector nullVector, MultiVector result, 
            bool isValid) -> NOX::Abstract::Group::ReturnType
        """
        return _MooreSpence.FiniteDifferenceGroup_computeDJnDpMulti(self, *args)

    def computeDJnDxaMulti(self, *args):
        """
        computeDJnDxaMulti(FiniteDifferenceGroup self, Vector nullVector, MultiVector aVector, MultiVector result) -> NOX::Abstract::Group::ReturnType
        computeDJnDxaMulti(FiniteDifferenceGroup self, Vector nullVector, Vector JnVector, MultiVector aVector, MultiVector result) -> NOX::Abstract::Group::ReturnType
        """
        return _MooreSpence.FiniteDifferenceGroup_computeDJnDxaMulti(self, *args)

    def computeDwtJnDxMulti(self, *args):
        """computeDwtJnDxMulti(FiniteDifferenceGroup self, MultiVector w, Vector nullVector, MultiVector result) -> NOX::Abstract::Group::ReturnType"""
        return _MooreSpence.FiniteDifferenceGroup_computeDwtJnDxMulti(self, *args)

FiniteDifferenceGroup_swigregister = _MooreSpence.FiniteDifferenceGroup_swigregister
FiniteDifferenceGroup_swigregister(FiniteDifferenceGroup)

class SolverFactory(_object):
    """Proxy of C++ LOCA::TurningPoint::MooreSpence::SolverFactory class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, SolverFactory, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, SolverFactory, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """__init__(LOCA::TurningPoint::MooreSpence::SolverFactory self, Teuchos::RCP< LOCA::GlobalData > const & global_data) -> SolverFactory"""
        this = _MooreSpence.new_SolverFactory(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _MooreSpence.delete_SolverFactory
    def create(self, *args):
        """create(SolverFactory self, Teuchos::RCP< LOCA::Parameter::SublistParser > const & topParams, Teuchos::RCP< Teuchos::ParameterList > const & solverParams) -> Teuchos::RCP< LOCA::TurningPoint::MooreSpence::SolverStrategy >"""
        return _MooreSpence.SolverFactory_create(self, *args)

    def strategyName(self, *args):
        """strategyName(SolverFactory self, ParameterList solverParams) -> std::string const &"""
        return _MooreSpence.SolverFactory_strategyName(self, *args)

SolverFactory_swigregister = _MooreSpence.SolverFactory_swigregister
SolverFactory_swigregister(SolverFactory)

# This file is compatible with both classic and new-style classes.


